;Sample POOL code, you may use it, modify it
;and distribute it under the GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

;Class for turtles drawing lines:
; h0 - initial heading
; c  - line color
to model :h0 :c
  to onsignalstep ;handling function for "step" signal:
    "a += rnorm 2    ;small, random change of heading
    "v += rnorm 0.01 ;and step length
    if abs :a > 30 ["a := 30 * sign :a]
    if :v > 10 ["v := 10]
    if :v < 0 ["v := 0]
    rt :a fd :v
  end

  let "v 3 ;initial step length
  let "a 0 ;initial heading change
  (setpc :c 30)
  seth :h0
end

rerandom int timemilli ;initialize the random number generator
wrap hideturtle
setbg "black

"n := 1000
repeat :n [ ;create :n turtles of the "model" class
  let "h 360 * repcount / :n
  let "c 1000 * repcount / :n
  let "t (anewt $model :h :c) ;asynchronous constructor
]

shared "go  ;variable accessible to all turtles
"go := true ;"false" will freeze the drawing

"b := (button "Stop {20 10 60 24} [
  "go := not :go
  ifelse :go [settext :b "Stop] [settext :b "|Go!|]
])

;an independent turtle is sending signals, therefore
; #first can listen to the command line
"u := (anewt [forever [ifelse :go [signalw "step] [wait 10]]])
